# Class PopupContentExtension

Extends the capabilities of an Esri popup Content object.

#### Hierarchy (view full)

- EntityBase<PopupContentExtensionProperties>
  - PopupContentExtension

#####
Index

### Constructors

constructor

### Properties

_deferredContentProperties
_handles
_id
_itemType
@eventTypes
summaryHiddenFields
visibleInSummary

### Accessors

content
failureMode
featureSettings
id
isDestroyed
isInitialized
itemType

### Methods

_getSerializableProperties
_initializableChildCollections
_initializeChildren
_onDestroy
_onInitialize
_postInitialize
_toPropertyDef
assignProperties
assignPropertiesAsync
destroy
finishAssignProperties
getDefault
getDefaults
getSerializableProperties
initialize
toItemUri
toJSON
matchesRef

##
Constructors

### constructor

- new PopupContentExtension(properties?): PopupContentExtension

- Creates a new instance of PopupContentExtension.

  #### Parameters

  - `Optional` properties: PopupContentExtensionProperties

    An object containing initial property values to set.

  #### Returns PopupContentExtension

  Overrides EntityBase.constructor

##
Properties

### _deferredContentProperties

_deferredContentProperties: ContentProperties

### `Protected` `Readonly`_handles

_handles: Handles<unknown, ResourceHandle>

Inherited from EntityBase._handles

### `Protected`_id

_id: string

The unique ID for this entity. Once set, this should never change.

Inherited from EntityBase._id

### `Protected` `Readonly`_itemType

_itemType: string = ItemType.POPUP_CONTENT_EXTENSION

The item type for this entity when it participates in an App.

Overrides EntityBase._itemType

### @eventTypes

@eventTypes: InitializableBaseEvents

#### Deprecated

Do not directly reference this property. Use EventNames and EventTypes helpers from @arcgis/core/Evented.

Inherited from EntityBase.@eventTypes

### summaryHiddenFields

summaryHiddenFields: Collection<string> = ...

### visibleInSummary

visibleInSummary: boolean

##
Accessors

### content

- get content(): Content

- The Esri PopupContent object being extended.

  #### Returns Content

### failureMode

- get failureMode(): FailureMode

- Determines how a parent object should handle initialization failure in this object. The default is "warn".

  - `"error"`: support/InitializeError!InitializeError is thrown.
  - `"warn"`: Message is logged and support/InitializableBase!InitializeWarningEvent is raised.
  - `"ignore"`: support/InitializableBase!InitializeWarningEvent is raised.

  #### Returns FailureMode

  Inherited from EntityBase.failureMode

- set failureMode(value): void

- #### Parameters

  - value: FailureMode

  #### Returns void

  Inherited from EntityBase.failureMode

### featureSettings

- get featureSettings(): FeatureSettings

- The parent featureSettings.

  #### Returns FeatureSettings

### id

- get id(): string

- The unique ID for this entity.

  #### Returns string

  Inherited from EntityBase.id

### isDestroyed

- get isDestroyed(): boolean

- See support/InitializableBase!Initializable.isDestroyed.

  #### Returns boolean

  Inherited from EntityBase.isDestroyed

### isInitialized

- get isInitialized(): boolean

- See support/InitializableBase!Initializable.isInitialized.

  #### Returns boolean

  Inherited from EntityBase.isInitialized

### itemType

- get itemType(): string

- The item type for this entity when it participates in an App.

  #### Returns string

  Inherited from EntityBase.itemType

##
Methods

### `Protected`_getSerializableProperties

- _getSerializableProperties(): PropertyDefs<PopupContentExtensionProperties>

- The property keys and their metadata that are used to implement serializing and deserializing the class instance.

  #### Returns PropertyDefs<PopupContentExtensionProperties>

  Overrides EntityBase._getSerializableProperties

### `Protected`_initializableChildCollections

- _initializableChildCollections(): IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

- Collections of child items to initialize. Items that fail to initialize are removed from the collection.

  #### Returns IterableIterator<Collection<InitializableBase<InitializableBaseProperties>>, any, any>

  Inherited from EntityBase._initializableChildCollections

### `Protected`_initializeChildren

- _initializeChildren(): Promise<void>

- Initializes child entities.

  #### Returns Promise<void>

  Inherited from EntityBase._initializeChildren

### `Protected`_onDestroy

- _onDestroy(): Promise<void>

- Called to perform cleanup. Subclasses should override this method rather than destroy() to perform custom cleanup.

  #### Returns Promise<void>

  Inherited from EntityBase._onDestroy

### `Protected`_onInitialize

- _onInitialize(): Promise<void>

- Called to perform initialization of the support/InitializableBase!InitializableBase. Subclasses should override this method rather than initialize() to perform custom initialization.

  #### Returns Promise<void>

  Overrides EntityBase._onInitialize

### `Protected`_postInitialize

- _postInitialize(): Promise<void>

- Called after normal initialization. Note: Child items are initialized before this is called.

  #### Returns Promise<void>

  Inherited from EntityBase._postInitialize

### `Protected`_toPropertyDef

- _toPropertyDef<T>(def): PropertyDef<T>

- Converts the value to a PropertyDef object.

  #### Type Parameters

  - T

  #### Parameters

  - def: PropertyDefSerializeMode | PropertyDefSerializeMode[] | PropertyDef<T>

    The value to convert.

  #### Returns PropertyDef<T>

  Inherited from EntityBase._toPropertyDef

### assignProperties

- assignProperties(properties): void

- #### Parameters

  - properties: Partial<PopupContentExtensionProperties>

  #### Returns void

  #### Inherit Doc

  Inherited from EntityBase.assignProperties

### assignPropertiesAsync

- assignPropertiesAsync(properties): Promise<void>

- #### Parameters

  - properties: Partial<PopupContentExtensionProperties>

  #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.assignPropertiesAsync

### destroy

- destroy(): Promise<void>

- A clean-up function that should get called whenever the item is disposed of.

  #### Returns Promise<void>

  Overrides EntityBase.destroy

### finishAssignProperties

- finishAssignProperties(): Promise<void>

- #### Returns Promise<void>

  #### Inherit Doc

  Inherited from EntityBase.finishAssignProperties

### getDefault

- getDefault<K>(key): PopupContentExtensionProperties[K]

- #### Type Parameters

  - K extends keyof PopupContentExtensionProperties

  #### Parameters

  - key: K

  #### Returns PopupContentExtensionProperties[K]

  #### Inherit Doc

  Inherited from EntityBase.getDefault

### getDefaults

- getDefaults(): PopupContentExtensionProperties

- #### Returns PopupContentExtensionProperties

  #### Inherit Doc

  Inherited from EntityBase.getDefaults

### getSerializableProperties

- getSerializableProperties(serializeMode?): PropertyDefs<PopupContentExtensionProperties>

- Returns the serializable properties.

  #### Parameters

  - `Optional` serializeMode: SerializeMode

    Optional. If specified, only properties that support the given serialization mode will be returned.

  #### Returns PropertyDefs<PopupContentExtensionProperties>

  Inherited from EntityBase.getSerializableProperties

### initialize

- initialize(): Promise<void>

- Initializes the item.

  #### Returns Promise<void>

  Inherited from EntityBase.initialize

### toItemUri

- toItemUri(): string

- Creates an item:// URI reference to this entity.

  #### Returns string

  Inherited from EntityBase.toItemUri

### toJSON

- toJSON(serializeMode?): PopupContentExtensionProperties

- #### Parameters

  - serializeMode: SerializeMode = "all"

  #### Returns PopupContentExtensionProperties

  #### Inherit Doc

  Inherited from EntityBase.toJSON

### `Static` matchesRef

- matchesRef(popupContent, popupContentIndex, popupContentRef): boolean

- Checks to see if a popup Content item matches a popup Content reference.

  #### Parameters

  - popupContent: (Content | PopupContentExtension)[]

    The popupContent or PopupContentExtension to match with a reference.

  - popupContentIndex: number

    The index of the Content or PopupContentExtension relative to the array of PopupContent.

  - popupContentRef: ContentProperties

    The popupContent reference to match with a popupContent.

  #### Returns boolean